Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobAdapter.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobAdapter.cs	(revision 3011)
@@ -28,10 +28,10 @@
 
 namespace HeuristicLab.Hive.Server.DataAccess {
-  public interface IJobAdapter: IDataAdapter<Job> {
+  public interface IJobAdapter: IDataAdapter<JobDto> {
     /// <summary>
     /// Gets all subjobs of the specified job
     /// </summary>
     /// <returns></returns>
-    ICollection<Job> GetAllSubjobs(Job job);
+    ICollection<JobDto> GetAllSubjobs(JobDto job);
 
     /// <summary>
@@ -39,5 +39,5 @@
     /// </summary>
     /// <returns></returns>
-    ICollection<Job> GetJobsByState(State state);
+    ICollection<JobDto> GetJobsByState(State state);
 
     /// <summary>
@@ -49,5 +49,5 @@
     /// <param name="resourceId">all jobs that can be calculated by that resource</param>
     /// <returns></returns>
-    ICollection<Job> FindJobs(State state, 
+    ICollection<JobDto> FindJobs(State state, 
       int cores, 
       int memory, 
@@ -59,5 +59,5 @@
     /// <param name="client"></param>
     /// <returns></returns>
-    ICollection<Job> GetJobsOf(ClientInfo client);
+    ICollection<JobDto> GetJobsOf(ClientDto client);
 
     /// <summary>
@@ -66,5 +66,5 @@
     /// <param name="client"></param>
     /// <returns></returns>
-    ICollection<Job> GetActiveJobsOf(ClientInfo client);
+    ICollection<JobDto> GetActiveJobsOf(ClientDto client);
 
     /// <summary>
@@ -73,5 +73,5 @@
     /// <param name="user"></param>
     /// <returns></returns>
-    ICollection<Job> GetJobsOf(Guid userId);
+    ICollection<JobDto> GetJobsOf(Guid userId);
 
     /// <summary>
@@ -80,5 +80,5 @@
     /// <param name="user"></param>
     /// <returns></returns>
-    ICollection<Job> GetJobsByProject(Guid projectId);
+    ICollection<JobDto> GetJobsByProject(Guid projectId);
 
     /// <summary>
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3011)
@@ -0,0 +1,24 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.IO;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IJobDao: IGenericDao<JobDto> {
+    IEnumerable<JobDto> FindActiveJobsOfClient(ClientDto client);
+
+    IEnumerable<JobDto> GetJobsByState(State state);
+
+    void AssignClientToJob(Guid clientId, Guid jobId);
+
+    void SetJobOffline(JobDto job);
+
+    SerializedJob InsertWithAttachedJob(SerializedJob job);
+
+    byte[] GetBinaryJobFile(Guid jobId); 
+
+    IEnumerable<JobDto> FindFittingJobsForClient(State state, int freeCores, int freeMemory);
+    Stream GetSerializedJobStream(Guid jobId);
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoAdapter.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoAdapter.cs	(revision 3011)
@@ -30,8 +30,8 @@
   /// The plugin info database adapter
   /// </summary>
-  public interface IPluginInfoAdapter : IDataAdapter<HivePluginInfo> {
-    HivePluginInfo GetByNameVersionBuilddate(String name, String version, DateTime buildDate);
+  public interface IPluginInfoAdapter : IDataAdapter<HivePluginInfoDto> {
+    HivePluginInfoDto GetByNameVersionBuilddate(String name, String version, DateTime buildDate);
 
-    ICollection<HivePluginInfo> GetOrphanedPluginInfos();
+    ICollection<HivePluginInfoDto> GetOrphanedPluginInfos();
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs	(revision 3011)
@@ -0,0 +1,10 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IPluginInfoDao: IGenericDao<HivePluginInfoDto> {    
+    void InsertPluginDependenciesForJob(JobDto jobDto);
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IProjectAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IProjectAdapter.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IProjectAdapter.cs	(revision 3011)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.Hive.Server.DataAccess {
-  public interface IProjectAdapter : IDataAdapter<Project> {
+  public interface IProjectAdapter : IDataAdapter<ProjectDto> {
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IResourceAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IResourceAdapter.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IResourceAdapter.cs	(revision 3011)
@@ -1,3 +1,3 @@
-﻿#region License Information
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -30,5 +30,5 @@
   /// The resource database adapter
   /// </summary>
-  public interface IResourceAdapter: IPolymorphicDataAdapter<Resource> {
+  public interface IResourceAdapter: IPolymorphicDataAdapter<ResourceDto> {
     /// <summary>
     /// Gets the resource and updates the values of the object
@@ -36,5 +36,5 @@
     /// <param name="resource"></param>
     /// <returns></returns>
-    bool GetById(Resource resource);
+    bool GetById(ResourceDto resource);
 
     /// <summary>
@@ -43,5 +43,5 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    Resource GetByName(string name);
+    ResourceDto GetByName(string name);
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/VarBinaryStream.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/VarBinaryStream.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/VarBinaryStream.cs	(revision 3011)
@@ -0,0 +1,277 @@
+/* Based on: 
+ *   http://www.eggheadcafe.com/conversation.aspx?messageid=29988910&threadid=29988841
+ * */
+
+using System;
+using System.IO;
+using System.Data.SqlClient;
+using System.Data;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  /// <summary>
+  /// The VarBinaryStream class inherits from Stream. It uses a
+  /// VarBinarySource class to execute the actual TSQL.
+  /// </summary>
+  public class VarBinaryStream : Stream, IDisposable {
+    private long _position;
+    private readonly VarBinarySource _source;
+
+    public VarBinaryStream(VarBinarySource source) {
+      _position = 0;
+      _source = source;
+    }
+
+    public override bool CanRead {
+      get { return true; }
+    }
+
+    public override bool CanSeek {
+      get { return true; }
+    }
+
+    public override bool CanWrite {
+      get { return true; }
+    }
+
+    public override long Length {
+      get { return _source.Length; }
+    }
+
+    public override long Position {
+      get { return _position; }
+      set { this.Seek(value, SeekOrigin.Begin); }
+    }
+
+    public override void Flush() { }
+
+    public override long Seek(long offset, SeekOrigin origin) {
+      switch (origin) {
+        case SeekOrigin.Begin: {
+            if ((offset < 0) && (offset > this.Length))
+              throw new ArgumentException("Invalid seek origin.");
+            _position = offset;
+            break;
+          }
+        case SeekOrigin.End: {
+            if ((offset > 0) && (offset < -this.Length))
+              throw new ArgumentException("Invalid seek origin.");
+            _position = this.Length - offset;
+            break;
+          }
+        case SeekOrigin.Current: {
+            if ((_position + offset > this.Length))
+              throw new ArgumentException("Invalid seek origin.");
+            _position = _position + offset;
+            break;
+          }
+        default: {
+            throw new ArgumentOutOfRangeException("origin");
+          }
+      }
+      return _position;
+    }
+
+    public override void SetLength(long value) {
+      throw new NotSupportedException();
+    }
+
+    public override int Read(byte[] buffer, int offset, int count) {
+      if (buffer == null)
+        throw new ArgumentNullException("buffer");
+      if (offset < 0)
+        throw new ArgumentOutOfRangeException("offset");
+      if (count < 0)
+        throw new ArgumentOutOfRangeException("count");
+      if (buffer.Length - offset < count)
+        throw new ArgumentException("Offset and length were out of bounds for the array");
+
+      byte[] data = _source.Read(Position, count);
+      if (data == null)
+        return 0;
+
+      Buffer.BlockCopy(data, 0, buffer, offset, data.Length);
+      _position += data.Length;
+      return data.Length;
+    }
+
+    public override void Write(byte[] buffer, int offset, int count) {
+      if (buffer == null)
+        throw new ArgumentNullException("buffer");
+      if (offset < 0)
+        throw new ArgumentOutOfRangeException("offset");
+      if (count < 0)
+        throw new ArgumentOutOfRangeException("count");
+      if (buffer.Length - offset < count)
+        throw new ArgumentException("Offset and length were out of bounds for the array");
+
+      byte[] data = GetWriteBuffer(buffer, count, offset);
+      _source.Write(data, _position, count);
+      _position += count;
+    }
+
+    private static byte[] GetWriteBuffer(byte[] buffer, int count, int
+    offset) {
+      if (buffer.Length == count)
+        return buffer;
+      byte[] data = new byte[count];
+      Buffer.BlockCopy(buffer, offset, data, 0, count);
+      return data;
+    }
+
+    public override void Close() {
+      _source.Close();
+    }
+
+    protected override void Dispose(bool disposing) {
+      if (!disposing) {
+        if (_source != null) {
+          _source.Close();
+          _source.Dispose();
+        }
+      }
+      base.Dispose(disposing);
+    }
+  }
+
+
+  public class VarBinarySource : IDisposable {
+    private SqlCommand _readCommand;
+    private SqlCommand _writeCommand;
+    private SqlConnection _connection;
+    private SqlTransaction _transaction;
+    private bool _ownedTransaction = false;
+    private bool _ownedConnection = false;
+    private readonly long _length;
+
+    public VarBinarySource(SqlConnection connection,
+      SqlTransaction transaction,
+      string table, string
+    dataColumn, string keyColumn, Guid key) {
+      _connection = connection;
+      
+      if (_connection.State == ConnectionState.Closed) {
+        _connection.Open();
+        _ownedConnection = true;
+
+        _transaction =
+          _connection.BeginTransaction(IsolationLevel.RepeatableRead) as SqlTransaction;
+        _ownedTransaction = true;
+      } else {
+        _ownedConnection = false;
+
+        if (transaction != null) {
+          _transaction = transaction;
+
+          _ownedTransaction = false;
+        } else {
+          _transaction =
+            _connection.BeginTransaction(IsolationLevel.ReadCommitted) as SqlTransaction;
+
+          _ownedTransaction = true;
+        }
+      }
+
+      _length = GetLength(connection, table, dataColumn, keyColumn, key);
+      _readCommand = CreateReadCommand(connection, table, dataColumn,
+      keyColumn, key);
+      _writeCommand = CreateWriteCommand(connection, table, dataColumn,
+      keyColumn, key);
+    }
+
+    public long Length {
+      get { return _length; }
+    }
+
+    private static SqlCommand CreateReadCommand(SqlConnection connection,
+    string table, string dataColumn, string keyColumn,
+    Guid key) {
+      SqlCommand readCommand = connection.CreateCommand();
+      readCommand.CommandText = string.Format(@"
+select substring({0}, @offset, @length)
+from {1}
+where {2} = @key", dataColumn, table, keyColumn);
+      readCommand.Parameters.Add("@key", SqlDbType.UniqueIdentifier).Value = key;
+      readCommand.Parameters.Add("@offset", SqlDbType.BigInt);
+      readCommand.Parameters.Add("@length", SqlDbType.BigInt);
+      return readCommand;
+    }
+
+    private static SqlCommand CreateWriteCommand(SqlConnection connection,
+    string table, string dataColumn, string keyColumn,
+    Guid key) {
+      SqlCommand writecommand = connection.CreateCommand();
+      writecommand.CommandText = string.Format(@"
+update {0}
+set {1}.write(@buffer, @offset, @length)
+where {2} = @key", table, dataColumn, keyColumn);
+      writecommand.Parameters.Add("@key", SqlDbType.UniqueIdentifier).Value = key;
+      writecommand.Parameters.Add("@offset", SqlDbType.BigInt);
+      writecommand.Parameters.Add("@length", SqlDbType.BigInt);
+      writecommand.Parameters.Add("@buffer", SqlDbType.VarBinary);
+      return writecommand;
+    }
+
+    private long GetLength(SqlConnection connection,
+      string table,
+    string dataColumn, string keyColumn,
+    Guid key) {
+      using (SqlCommand command = connection.CreateCommand()) {
+        command.Transaction = _transaction;
+
+        SqlParameter length = command.Parameters.Add("@length",
+        SqlDbType.BigInt);
+        length.Direction = ParameterDirection.Output;
+
+        command.CommandText = string.Format(@"
+select @length = cast(datalength({0}) as bigint)
+from {1}
+where {2} = @key", dataColumn, table, keyColumn);
+        command.Parameters.Add("@key", SqlDbType.UniqueIdentifier).Value = key;
+        command.ExecuteNonQuery();
+        return length.Value == DBNull.Value ? 0 : (long)length.Value;
+      }
+    }
+
+    public byte[] Read(long offset, long length) {
+      _readCommand.Transaction = _transaction;
+
+      // substring is 1-based.
+      _readCommand.Parameters["@offset"].Value = offset + 1;
+      _readCommand.Parameters["@length"].Value = length;
+      return (byte[])_readCommand.ExecuteScalar();
+    }
+
+    public void Write(byte[] buffer, long offset, long length) {
+      _writeCommand.Transaction = _transaction;
+
+      _writeCommand.Parameters["@buffer"].Value = buffer;
+      _writeCommand.Parameters["@offset"].Value = offset;
+      _writeCommand.Parameters["@length"].Value = length;
+      _writeCommand.ExecuteNonQuery();
+    }
+
+    public void Close() {
+      if (_transaction != null) {
+        if (_ownedTransaction)
+          _transaction.Commit();
+        _transaction = null;
+      }
+
+      if (_connection != null) {
+        if (_ownedConnection)
+          _connection.Close();
+        _connection = null;
+      }
+    }
+
+    public void Dispose() {
+      if (_readCommand != null) {
+        _readCommand.Dispose();
+      }
+      if (_writeCommand != null) {
+        _writeCommand.Dispose();
+      }
+    }
+  }
+}
+
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3011)
@@ -5,5 +5,5 @@
 
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
-  public class BaseDao {
+  public abstract class BaseDao<TBusiness, TDatabaseEntity> {
     public static HiveDataContext Context {
       get {
@@ -11,4 +11,8 @@
       }
     }
+
+    public abstract TDatabaseEntity DtoToEntity(TBusiness source, TDatabaseEntity target);
+    public abstract TBusiness EntityToDto(TDatabaseEntity source, TBusiness target);
+
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs	(revision 3011)
@@ -0,0 +1,71 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+
+namespace HeuristicLab.Hive.Server.LINQDataAccess {
+  public class ClientConfigDao: BaseDao<ClientConfigDto, ClientConfig>, IClientConfigDao {
+
+
+    #region IGenericDao<ClientConfigDto,ClientConfig> Members
+
+    public ClientConfigDto FindById(Guid id) {
+      return (from cc in Context.ClientConfigs
+              where cc.ClientConfigId.Equals(id)
+              select EntityToDto(cc, null)).SingleOrDefault();
+    }
+
+    public IEnumerable<ClientConfigDto> FindAll() {
+      return (from cc in Context.ClientConfigs              
+              select EntityToDto(cc, null)).ToList();
+    }
+
+    public ClientConfigDto Insert(ClientConfigDto bObj) {
+      ClientConfig c = DtoToEntity(bObj, null);
+      Context.ClientConfigs.InsertOnSubmit(c);
+      Context.SubmitChanges();
+      bObj.Id = c.ClientConfigId;
+      return bObj;  
+    }
+
+    public void Delete(ClientConfigDto bObj) {
+      Context.ClientConfigs.DeleteOnSubmit(Context.ClientConfigs.SingleOrDefault(c => c.ClientConfigId.Equals(bObj.Id)));
+      Context.SubmitChanges();
+    }
+
+    public void Update(ClientConfigDto bObj) {
+      ClientConfig cc = Context.ClientConfigs.SingleOrDefault(c => c.ClientConfigId.Equals(bObj.Id));
+      DtoToEntity(bObj, cc);
+      Context.SubmitChanges();
+    }
+
+    #endregion
+
+    public override ClientConfig DtoToEntity(ClientConfigDto source, ClientConfig target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new ClientConfig();
+
+      target.ClientConfigId = source.Id;
+      target.HeartBeatIntervall = source.HeartBeatIntervall;
+      
+      return target;
+    }
+
+    public override ClientConfigDto EntityToDto(ClientConfig source, ClientConfigDto target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new ClientConfigDto();
+
+      target.Id = source.ClientConfigId;
+      target.HeartBeatIntervall = source.HeartBeatIntervall;
+
+      return target;
+
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs	(revision 3011)
@@ -4,59 +4,41 @@
 using System.Text;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
-  public class ClientDao: BaseDao, IClientDao {
+  public class ClientDao: BaseDao<ClientDto, Client>, IClientDao {
 
     public ClientDao() {      
     }
 
-    public ClientInfo FindById(Guid id) {
+    public ClientDto FindById(Guid id) {
       return (from client in Context.Clients
               where client.ResourceId.Equals(id)
-              select
-                new ClientInfo {
-                  CpuSpeedPerCore = client.CPUSpeed,
-                  FreeMemory = client.FreeMemory,
-                  Id = client.ResourceId,
-                  Login = client.Login,
-                  Memory = client.Memory,
-                  Name = client.Resource.Name,
-                  NrOfCores = client.NumberOfCores,
-                  NrOfFreeCores = client.NumberOfFreeCores,
-                  State = (State)Enum.Parse(typeof(State), client.Status)
-                }
+              select EntityToDto(client, null)
             ).SingleOrDefault();      
     }
 
-    public IEnumerable<ClientInfo> FindAll() {
+    public IEnumerable<ClientDto> FindAll() {
       return (from client in Context.Clients
               select
-                new ClientInfo {
-                                 CpuSpeedPerCore = client.CPUSpeed,
-                                 FreeMemory = client.FreeMemory,
-                                 Id = client.ResourceId,
-                                 Login = client.Login,
-                                 Memory = client.Memory,
-                                 Name = client.Resource.Name,
-                                 NrOfCores = client.NumberOfCores,
-                                 NrOfFreeCores = client.NumberOfFreeCores,
-                                 State = (State) Enum.Parse(typeof (State), client.Status)
-                               }
+                EntityToDto(client, null)
              ).ToList();
     }
 
+    public IEnumerable<ClientDto> FindAllClientsWithoutGroup() {
+      return (from client in Context.Clients
+              where client.Resource.ClientGroup_Resources.Count == 0
+              select EntityToDto(client, null)).ToList();
+    }
+
+    public ClientDto GetClientForJob(Guid jobId) {
+      return (from job in Context.Jobs
+              where job.JobId.Equals(jobId)
+              select EntityToDto(job.Client, null)).SingleOrDefault();
+    }
  
-    public ClientInfo Insert(ClientInfo info) {
-      Client c = new Client {
-                              CPUSpeed = info.CpuSpeedPerCore,
-                              FreeMemory = info.FreeMemory,
-                              Resource = new Resource {Name = info.Name, ResourceId = info.Id},
-                              Login = info.Login,
-                              Memory = info.Memory,
-                              NumberOfCores = info.NrOfCores,
-                              NumberOfFreeCores = info.NrOfFreeCores,
-                              Status = Enum.GetName(typeof (State), info.State)
-                            };
-
+    public ClientDto Insert(ClientDto info) {
+      Client c = DtoToEntity(info, null);      
       Context.Clients.InsertOnSubmit(c);
       Context.SubmitChanges();
@@ -65,29 +47,61 @@
     }
 
-    public void Delete(ClientInfo info) {
-      Client client = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(info.Id));
-      Context.Clients.DeleteOnSubmit(client);
-    }
-
-    public void Update(ClientInfo info) {
-      Client client = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(info.Id));
-      client.CPUSpeed = info.CpuSpeedPerCore;
-      client.FreeMemory = info.FreeMemory;
-      client.Resource.Name = info.Name;
-      client.Login = info.Login;
-      client.Memory = info.Memory;
-      client.NumberOfCores = info.NrOfCores;
-      client.NumberOfFreeCores = info.NrOfFreeCores;
-      client.Status = Enum.GetName(typeof (State), info.State);
+    //Cascading delete takes care of the rest
+    public void Delete(ClientDto info) {
+      Resource res = Context.Resources.SingleOrDefault(c => c.ResourceId.Equals(info.Id));            
+      Context.Resources.DeleteOnSubmit(res);
       Context.SubmitChanges();
     }
 
+    public void Update(ClientDto info) {
+      Client client = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(info.Id));
+      DtoToEntity(info, client);
+      try {
+        Console.WriteLine("Sending from thread: " + Thread.CurrentThread.ManagedThreadId);
+        Context.SubmitChanges();
+      } catch (System.Data.Linq.ChangeConflictException cce) {
+        Console.WriteLine(cce);        
+      }
+    }
 
+    public override Client DtoToEntity(ClientDto source, Client target) {
+      if (source == null)
+        return null;
+      if (target == null) 
+        target = new Client();
+      
+      target.CPUSpeed = source.CpuSpeedPerCore;
+      
+      if(target.Resource == null)
+        target.Resource = new Resource();
 
-    #region IGenericDao<ClientInfo,Client> Members
+      target.FreeMemory = source.FreeMemory;
+      target.Resource.Name = source.Name;
+      target.Resource.ResourceId = source.Id;
 
+      target.Login = source.Login;
+      target.Memory = source.Memory;
+      target.NumberOfCores = source.NrOfCores;
+      target.NumberOfFreeCores = source.NrOfFreeCores;
+      target.Status = Enum.GetName(typeof(State), source.State);
+      return target;
+    }
 
-
-    #endregion
+    public override ClientDto EntityToDto(Client source, ClientDto target) {
+      if (source == null)
+        return null;
+      if(target == null) 
+        target = new ClientDto();
+      target.CpuSpeedPerCore = source.CPUSpeed;
+      target.FreeMemory = source.FreeMemory;
+      target.Id = source.ResourceId;
+      target.Login = source.Login;
+      target.Memory = source.Memory;
+      target.Name = source.Resource.Name;
+      target.NrOfCores = source.NumberOfCores;
+      target.NrOfFreeCores = source.NumberOfFreeCores;
+      target.State = (State) Enum.Parse(typeof (State), source.Status);
+      return target;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs	(revision 3011)
@@ -0,0 +1,143 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+
+namespace HeuristicLab.Hive.Server.LINQDataAccess {
+  public class ClientGroupDao : BaseDao<ClientGroupDto, ClientGroup>, IClientGroupDao {
+
+
+    #region IGenericDao<ClientGroupDto,ClientGroup> Members
+
+    public ClientGroupDto FindById(Guid id) {
+      return (from cc in Context.ClientGroups
+              where cc.ResourceId.Equals(id)
+              select EntityToDto(cc, null)).SingleOrDefault();
+    }
+
+
+    public IEnumerable<ClientGroupDto> FindAll() {
+      return (from cc in Context.ClientGroups
+              select EntityToDto(cc, null)).ToList();
+    }
+
+    public ClientGroupDto Insert(ClientGroupDto bObj) {
+      //Auto GUID is disabled for Ressource... thx to the clients... grml      
+      if(bObj.Id == Guid.Empty)
+        bObj.Id = Guid.NewGuid();
+
+      ClientGroup cc = DtoToEntity(bObj, null);
+      Context.ClientGroups.InsertOnSubmit(cc);
+      Context.SubmitChanges();
+      bObj.Id = cc.ResourceId;
+      return bObj;
+    }
+
+    public void Delete(ClientGroupDto bObj) {
+      
+      //Deleting all references
+      Context.ClientGroup_Resources.DeleteAllOnSubmit(Context.ClientGroup_Resources.Where(cg => cg.ClientGroupId.Equals(bObj.Id)));
+
+      Resource res = Context.Resources.SingleOrDefault(c => c.ResourceId.Equals(bObj.Id));
+
+      Context.Resources.DeleteOnSubmit(res);
+      Context.SubmitChanges();
+    }
+
+    public void Update(ClientGroupDto bObj) {
+      ClientGroup client = Context.ClientGroups.SingleOrDefault(c => c.ResourceId.Equals(bObj.Id));
+      DtoToEntity(bObj, client);
+      Context.SubmitChanges();
+    }
+
+    public void AddRessourceToClientGroup(Guid resource, Guid clientGroupId) {
+      ClientGroup cg = Context.ClientGroups.SingleOrDefault(c => c.ResourceId.Equals(clientGroupId));
+      Resource res = Context.Resources.SingleOrDefault(r => r.ResourceId.Equals(resource));
+      cg.ClientGroup_Resources.Add(new ClientGroup_Resource { ClientGroup = cg, Resource = res });
+      Context.SubmitChanges();
+    }
+
+    public void RemoveRessourceFromClientGroup(Guid resource, Guid clientGroupId) {
+      ClientGroup_Resource cgr =
+        Context.ClientGroup_Resources.SingleOrDefault(
+          cg => cg.ResourceId.Equals(resource) && cg.ClientGroupId.Equals(clientGroupId));
+      Context.ClientGroup_Resources.DeleteOnSubmit(cgr);
+      Context.SubmitChanges();
+    }
+
+    public IEnumerable<ClientGroupDto> MemberOf(ClientDto client) {
+      return (from cgr in Context.ClientGroup_Resources
+              where cgr.ResourceId.Equals(client.Id)
+              select EntityToDto(cgr.ClientGroup, null)).ToList();
+    }
+
+    public IEnumerable<ClientGroupDto> FindAllWithSubGroupsAndClients() {
+      List<ClientGroupDto> groupList = new List<ClientGroupDto>();
+
+      var q = (from cg in Context.ClientGroups
+               where !Context.ClientGroup_Resources.Any(cgr => cgr.ResourceId.Equals(cg.ResourceId))
+               select cg);
+
+      foreach (ClientGroup cg in q) {
+        ClientGroupDto cgd = EntityToDto(cg, null);
+        groupList.Add(cgd);
+        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources);        
+      }
+      return groupList;
+    }
+
+    private void FillSubGroupsAndClientsRecursivly(ClientGroupDto parentClientGroup, System.Data.Linq.EntitySet<ClientGroup_Resource> parentResourceSet) {
+      ClientDao cd = new ClientDao();      
+      //Get all the Groups
+      
+      var qGroups = (from cg in Context.ClientGroups
+               where cg.Resource.ClientGroup_Resources.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
+               select cg);
+
+      foreach (ClientGroup cg in qGroups) {
+        ClientGroupDto cgd = EntityToDto(cg, null);
+        parentClientGroup.Resources.Add(cgd);
+        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources);
+      }
+
+      //get the clients
+      var qClients = (from cl in Context.Clients
+               where cl.Resource.ClientGroup_Resources.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
+               select cl);
+      foreach (Client client in qClients) {
+        parentClientGroup.Resources.Add(cd.EntityToDto(client, null));                        
+      }
+     
+    }
+
+    #endregion
+
+    public override ClientGroup DtoToEntity(ClientGroupDto source, ClientGroup target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new ClientGroup();
+      if (target.Resource == null)
+        target.Resource = new Resource();
+
+      target.Resource.Name = source.Name;
+      target.Resource.ResourceId = source.Id;
+
+      return target;
+    }
+
+    public override ClientGroupDto EntityToDto(ClientGroup source, ClientGroupDto target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new ClientGroupDto();
+
+      target.Id = source.ResourceId;
+      target.Name = source.Resource.Name;
+
+      return target;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs	(revision 3011)
@@ -15,4 +15,7 @@
         return _hiveDataContext;        
       } 
+      set {
+        _hiveDataContext = value;
+      }
     }
   }
